Index: test-integration/common/src/test/java/org/teiid/transport/TestJDBCSocketTransport.java
===================================================================
--- test-integration/common/src/test/java/org/teiid/transport/TestJDBCSocketTransport.java	(revision 3801)
+++ test-integration/common/src/test/java/org/teiid/transport/TestJDBCSocketTransport.java	(working copy)
@@ -109,6 +109,15 @@
 		assertEquals("<root></root>", s.getResultSet().getString(1));
 	}
 	
+	@Test public void testVarbinary() throws Exception {
+		Statement s = conn.createStatement();
+		assertTrue(s.execute("select X'aab1'"));
+		s.getResultSet().next();
+		byte[] bytes = s.getResultSet().getBytes(1);
+		assertArrayEquals(new byte[] {(byte)0xaa, (byte)0xb1}, bytes);
+		assertArrayEquals(bytes, s.getResultSet().getBlob(1).getBytes(1, 2));
+	}
+	
 	@Test public void testXmlTableScrollable() throws Exception {
 		Statement s = conn.createStatement(ResultSet.TYPE_SCROLL_INSENSITIVE, ResultSet.CONCUR_READ_ONLY);
 		assertTrue(s.execute("select * from xmltable('/root/row' passing (select xmlelement(name \"root\", xmlagg(xmlelement(name \"row\", xmlforest(t.name)) order by t.name)) from tables as t, columns as t1) columns \"Name\" string) as x"));
Index: engine/src/main/java/org/teiid/dqp/internal/process/RequestWorkItem.java
===================================================================
--- engine/src/main/java/org/teiid/dqp/internal/process/RequestWorkItem.java	(revision 3801)
+++ engine/src/main/java/org/teiid/dqp/internal/process/RequestWorkItem.java	(working copy)
@@ -52,7 +52,6 @@
 import org.teiid.core.types.DataTypeManager;
 import org.teiid.dqp.internal.process.DQPCore.CompletionListener;
 import org.teiid.dqp.internal.process.DQPCore.FutureWork;
-import org.teiid.dqp.internal.process.DQPWorkContext.Version;
 import org.teiid.dqp.internal.process.SessionAwareCache.CacheID;
 import org.teiid.dqp.internal.process.ThreadReuseExecutor.PrioritizedRunnable;
 import org.teiid.dqp.message.AtomicRequestID;
@@ -714,7 +713,7 @@
             dataTypes[i] = DataTypeManager.getDataTypeName(symbol.getType());
         }
         ResultsMessage result = new ResultsMessage(batch, columnNames, dataTypes);
-        result.setClientSerializationVersion((byte)(this.dqpWorkContext.getClientVersion().compareTo(Version.SEVEN_6) >= 0?1:0));
+        result.setClientSerializationVersion(this.dqpWorkContext.getClientVersion().getClientSerializationVersion());
         setAnalysisRecords(result);
         return result;
     }
Index: common-core/src/main/java/org/teiid/core/types/basic/BinaryToBlobTransform.java
===================================================================
--- common-core/src/main/java/org/teiid/core/types/basic/BinaryToBlobTransform.java	(revision 0)
+++ common-core/src/main/java/org/teiid/core/types/basic/BinaryToBlobTransform.java	(revision 0)
@@ -0,0 +1,61 @@
+/*
+ * JBoss, Home of Professional Open Source.
+ * See the COPYRIGHT.txt file distributed with this work for information
+ * regarding copyright ownership.  Some portions may be licensed
+ * to Red Hat, Inc. under one or more contributor license agreements.
+ * 
+ * This library is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU Lesser General Public
+ * License as published by the Free Software Foundation; either
+ * version 2.1 of the License, or (at your option) any later version.
+ * 
+ * This library is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * Lesser General Public License for more details.
+ * 
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with this library; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+ * 02110-1301 USA.
+ */
+
+package org.teiid.core.types.basic;
+
+import org.teiid.core.types.BinaryType;
+import org.teiid.core.types.DataTypeManager;
+import org.teiid.core.types.Transform;
+import org.teiid.core.types.TransformationException;
+
+public class BinaryToBlobTransform extends Transform {
+
+	/**
+	 * This method transforms a value of the source type into a value
+	 * of the target type.
+	 * @param value Incoming value of source type
+	 * @return Outgoing value of target type
+	 * @throws TransformationException if value is an incorrect input type or
+	 * the transformation fails
+	 */
+	public Object transformDirect(Object value) throws TransformationException {
+        BinaryType contents = (BinaryType)value;                
+		return contents.toBlob();
+	}
+
+	/**
+	 * Type of the incoming value.
+	 * @return Source type
+	 */
+	public Class<?> getSourceType() {
+		return DataTypeManager.DefaultDataClasses.VARBINARY;
+	}
+
+	/**
+	 * Type of the outgoing value.
+	 * @return Target type
+	 */
+	public Class<?> getTargetType() {
+		return DataTypeManager.DefaultDataClasses.BLOB;
+	}
+	
+}
Index: client/src/main/java/org/teiid/jdbc/CallableStatementImpl.java
===================================================================
--- client/src/main/java/org/teiid/jdbc/CallableStatementImpl.java	(revision 3801)
+++ client/src/main/java/org/teiid/jdbc/CallableStatementImpl.java	(working copy)
@@ -26,23 +26,10 @@
 import java.io.Reader;
 import java.math.BigDecimal;
 import java.net.URL;
-import java.sql.Array;
-import java.sql.Blob;
-import java.sql.CallableStatement;
-import java.sql.Clob;
-import java.sql.Date;
-import java.sql.NClob;
-import java.sql.Ref;
-import java.sql.RowId;
-import java.sql.SQLException;
-import java.sql.SQLXML;
-import java.sql.Time;
-import java.sql.Timestamp;
+import java.sql.*;
 import java.util.Calendar;
 import java.util.Map;
 
-import javax.sql.rowset.serial.SerialBlob;
-
 import org.teiid.client.RequestMessage;
 import org.teiid.client.RequestMessage.ResultsMode;
 import org.teiid.client.RequestMessage.StatementType;
@@ -545,7 +532,7 @@
 	}
 
 	public void setBytes(String parameterName, byte[] x) throws SQLException {
-		setObject((Object)parameterName, new SerialBlob(x));
+		setObject((Object)parameterName, x);
 	}
 
 	public void setCharacterStream(String parameterName, Reader reader)
Index: common-core/src/main/java/org/teiid/core/types/DataTypeManager.java
===================================================================
--- common-core/src/main/java/org/teiid/core/types/DataTypeManager.java	(revision 3801)
+++ common-core/src/main/java/org/teiid/core/types/DataTypeManager.java	(working copy)
@@ -190,6 +190,7 @@
 		public static final String BLOB = "blob"; //$NON-NLS-1$
 		public static final String CLOB = "clob"; //$NON-NLS-1$
 		public static final String XML = "xml"; //$NON-NLS-1$
+		public static final String VARBINARY = "varbinary"; //$NON-NLS-1$
 	}
 
 	public static final class DefaultDataClasses {
@@ -212,6 +213,7 @@
 		public static final Class<BlobType> BLOB = BlobType.class;
 		public static final Class<ClobType> CLOB = ClobType.class;
 		public static final Class<XMLType> XML = XMLType.class;
+		public static final Class<BinaryType> VARBINARY = BinaryType.class;
 	}
 	
 	public static final class DefaultTypeCodes {
@@ -234,9 +236,10 @@
 		public static final int CLOB = 16;
 		public static final int XML = 17;
 		public static final int NULL = 18;
+		public static final int VARBINARY = 19;
 	}
 	
-	public static int MAX_TYPE_CODE = DefaultTypeCodes.NULL;
+	public static int MAX_TYPE_CODE = DefaultTypeCodes.VARBINARY;
 	
     private static final Map<Class<?>, Integer> typeMap = new LinkedHashMap<Class<?>, Integer>(64);
     private static final List<Class<?>> typeList;
@@ -261,15 +264,24 @@
         typeMap.put(DataTypeManager.DefaultDataClasses.CLOB, DefaultTypeCodes.CLOB);
         typeMap.put(DataTypeManager.DefaultDataClasses.XML, DefaultTypeCodes.XML);
         typeMap.put(DataTypeManager.DefaultDataClasses.NULL, DefaultTypeCodes.NULL);
+        typeMap.put(DataTypeManager.DefaultDataClasses.VARBINARY, DefaultTypeCodes.VARBINARY);
         typeList = new ArrayList<Class<?>>(typeMap.keySet());
     }    
     
     public static int getTypeCode(Class<?> source) {
-        return typeMap.get(source).intValue();
+    	Integer result = typeMap.get(source);
+    	if (result == null) {
+    		return DefaultTypeCodes.OBJECT;
+    	}
+        return result;
     }
     
     public static Class<?> getClass(int code) {
-    	return typeList.get(code);
+    	Class<?> result = typeList.get(code);
+    	if (result == null) {
+    		return DefaultDataClasses.OBJECT;
+    	}
+    	return result;
     }
 
 	/**
@@ -568,6 +580,7 @@
 		DataTypeManager.addDataType(DefaultDataTypes.OBJECT, DefaultDataClasses.OBJECT);
 		DataTypeManager.addDataType(DefaultDataTypes.NULL, DefaultDataClasses.NULL);
 		DataTypeManager.addDataType(DefaultDataTypes.BLOB, DefaultDataClasses.BLOB);
+		DataTypeManager.addDataType(DefaultDataTypes.VARBINARY, DefaultDataClasses.VARBINARY);
 		DATA_TYPE_NAMES = Collections.unmodifiableSet(new LinkedHashSet<String>(dataTypeNames.keySet()));
 		dataTypeNames.put(DataTypeAliases.BIGINT, DefaultDataClasses.LONG);
 		dataTypeNames.put(DataTypeAliases.DECIMAL, DefaultDataClasses.BIG_DECIMAL);
@@ -600,8 +613,9 @@
 			valueMaps.put(DefaultDataClasses.DATE, new HashedValueCache<Date>(14));
 			valueMaps.put(DefaultDataClasses.TIME, new HashedValueCache<Time>(14));
 			valueMaps.put(DefaultDataClasses.TIMESTAMP, new HashedValueCache<Timestamp>(14));
-			valueMaps.put(DefaultDataClasses.BIG_DECIMAL, new WeakReferenceHashedValueCache<BigDecimal>(16));
+			valueMaps.put(DefaultDataClasses.BIG_DECIMAL, new WeakReferenceHashedValueCache<BigDecimal>(17));
 			valueMaps.put(DefaultDataClasses.STRING, stringCache);
+			valueMaps.put(DefaultDataClasses.VARBINARY, new WeakReferenceHashedValueCache<BinaryType>(17));
 		}
 	}
 
@@ -727,8 +741,12 @@
 		DataTypeManager.addTransform(new org.teiid.core.types.basic.StringToCharacterTransform());
 		DataTypeManager.addTransform(new org.teiid.core.types.basic.StringToClobTransform());
 		DataTypeManager.addTransform(new org.teiid.core.types.basic.StringToSQLXMLTransform());
-		
+
+		DataTypeManager.addTransform(new org.teiid.core.types.basic.BinaryToBlobTransform());
+
 		DataTypeManager.addTransform(new org.teiid.core.types.basic.ClobToStringTransform());
+
+		DataTypeManager.addTransform(new org.teiid.core.types.basic.BlobToBinaryTransform());
 		
 		DataTypeManager.addTransform(new org.teiid.core.types.basic.SQLXMLToStringTransform());
 		
@@ -752,28 +770,28 @@
 	}
 
 	static void loadSourceConversions() {
-		sourceConverters.put(Clob.class, new SourceTransform<Clob, ClobType>() {
+		addSourceTransform(Clob.class, new SourceTransform<Clob, ClobType>() {
 			@Override
 			public ClobType transform(Clob value) {
 				return new ClobType(value);
 			}
 		});
-		sourceConverters.put(char[].class, new SourceTransform<char[], ClobType>() {
+		addSourceTransform(char[].class, new SourceTransform<char[], ClobType>() {
 			@Override
 			public ClobType transform(char[] value) {
 				return new ClobType(ClobType.createClob(value));
 			}
 		});
-		sourceConverters.put(Blob.class, new SourceTransform<Blob, BlobType>() {
+		addSourceTransform(Blob.class, new SourceTransform<Blob, BlobType>() {
 			@Override
 			public BlobType transform(Blob value) {
 				return new BlobType(value);
 			}
 		});
-		addSourceTransform(byte[].class, new SourceTransform<byte[], BlobType>() {
+		addSourceTransform(byte[].class, new SourceTransform<byte[], BinaryType>() {
 			@Override
-			public BlobType transform(byte[] value) {
-				return new BlobType(BlobType.createBlob(value));
+			public BinaryType transform(byte[] value) {
+				return new BinaryType(value);
 			}
 		});
 		addSourceTransform(SQLXML.class, new SourceTransform<SQLXML, XMLType>() {
Index: client/src/main/java/org/teiid/client/BatchSerializer.java
===================================================================
--- client/src/main/java/org/teiid/client/BatchSerializer.java	(revision 3801)
+++ client/src/main/java/org/teiid/client/BatchSerializer.java	(working copy)
@@ -40,6 +40,7 @@
 import java.util.TimeZone;
 
 import org.teiid.core.TeiidRuntimeException;
+import org.teiid.core.types.BinaryType;
 import org.teiid.core.types.BlobType;
 import org.teiid.core.types.ClobType;
 import org.teiid.core.types.DataTypeManager;
@@ -72,6 +73,7 @@
         serializers.put(DataTypeManager.DefaultDataTypes.SHORT,         new ShortColumnSerializer());
         serializers.put(DataTypeManager.DefaultDataTypes.TIME,          new TimeColumnSerializer());
         serializers.put(DataTypeManager.DefaultDataTypes.TIMESTAMP,     new TimestampColumnSerializer());
+        serializers.put(DataTypeManager.DefaultDataTypes.VARBINARY,     new BinaryColumnSerializer());
     }
     
     private static final Map<String, ColumnSerializer> version1serializers = new HashMap<String, ColumnSerializer>(128);
@@ -84,9 +86,46 @@
     	version1serializers.put(DataTypeManager.DefaultDataTypes.XML,     		new XmlColumnSerializer1());
     	version1serializers.put(DataTypeManager.DefaultDataTypes.NULL,     		new NullColumnSerializer1());
     	version1serializers.put(DataTypeManager.DefaultDataTypes.OBJECT,     	new ObjectColumnSerializer1());
+    	version1serializers.put(DataTypeManager.DefaultDataTypes.VARBINARY,     new BinaryColumnSerializer1());
     }
     
-    public static final class ObjectColumnSerializer1 extends ColumnSerializer {
+    static class BinaryColumnSerializer1 extends ColumnSerializer {
+		@Override
+		protected void writeObject(ObjectOutput out, Object obj)
+				throws IOException {
+			byte[] bytes = ((BinaryType)obj).getBytes();
+			out.writeInt(bytes.length); //in theory this could be a short, but we're not strictly enforcing the length
+			out.write(bytes);
+		}
+		
+		@Override
+		protected Object readObject(ObjectInput in) throws IOException,
+				ClassNotFoundException {
+			int length = in.readInt();
+			byte[] bytes = new byte[length];
+			in.readFully(bytes);
+			return new BinaryType(bytes);
+		}
+	}
+    
+    static class BinaryColumnSerializer extends ColumnSerializer {
+		@Override
+		protected void writeObject(ObjectOutput out, Object obj)
+				throws IOException {
+			//uses object serialization for compatibility with legacy clients
+			super.writeObject(out, ((BinaryType)obj).getBytesDirect());
+		}
+		
+		@Override
+		protected Object readObject(ObjectInput in) throws IOException,
+				ClassNotFoundException {
+			//won't actually be used
+			byte[] bytes = (byte[])super.readObject(in);
+			return new BinaryType(bytes);
+		}
+	}
+
+	public static final class ObjectColumnSerializer1 extends ColumnSerializer {
     	
     	@Override
     	protected void writeObject(ObjectOutput out, Object obj)
@@ -532,7 +571,12 @@
         if (batch == null) {
             out.writeInt(-1);
         } else {
-            out.writeInt(batch.size());
+        	if (version > 0 && batch.size() > 0) {
+                out.writeInt(-batch.size() -1);
+                out.writeByte(version);
+        	} else {
+                out.writeInt(batch.size());
+        	}
             if (batch.size() > 0) {
 	            int columns = types.length;
 	            out.writeInt(columns);
@@ -558,27 +602,29 @@
     }
     
     public static List<List<Object>> readBatch(ObjectInput in, String[] types) throws IOException, ClassNotFoundException {
-    	return readBatch(in, types, (byte)1);
-    }
-    
-    public static List<List<Object>> readBatch(ObjectInput in, String[] types, byte version) throws IOException, ClassNotFoundException {
         int rows = in.readInt();
         if (rows == 0) {
             return new ArrayList<List<Object>>(0);
-        } else if (rows > 0) {
-            int columns = in.readInt();
-            List<List<Object>> batch = new ResizingArrayList<List<Object>>(rows);
-            int numBytes = rows/8;
-            int extraRows = rows % 8;
-            for (int currentRow = 0; currentRow < rows; currentRow++) {
-                batch.add(currentRow, Arrays.asList(new Object[columns]));
-            }
-            byte[] isNullBuffer = new byte[(extraRows > 0) ? numBytes + 1: numBytes];
-            for (int col = 0; col < columns; col++) {
-                getSerializer(types[col], version).readColumn(in, col, batch, isNullBuffer);
-            }
-            return batch;
+        }
+        if (rows == -1) {
+        	return null;
         }
-        return null;
+        byte version = (byte)0;
+        if (rows < 0) {
+        	rows = -(rows+1);
+        	version = in.readByte();
+        } 
+        int columns = in.readInt();
+        List<List<Object>> batch = new ResizingArrayList<List<Object>>(rows);
+        int numBytes = rows/8;
+        int extraRows = rows % 8;
+        for (int currentRow = 0; currentRow < rows; currentRow++) {
+            batch.add(currentRow, Arrays.asList(new Object[columns]));
+        }
+        byte[] isNullBuffer = new byte[(extraRows > 0) ? numBytes + 1: numBytes];
+        for (int col = 0; col < columns; col++) {
+            getSerializer(types[col], version).readColumn(in, col, batch, isNullBuffer);
+        }
+        return batch;
     }
 }
Index: api/src/main/java/org/teiid/language/visitor/SQLStringVisitor.java
===================================================================
--- api/src/main/java/org/teiid/language/visitor/SQLStringVisitor.java	(revision 3801)
+++ api/src/main/java/org/teiid/language/visitor/SQLStringVisitor.java	(working copy)
@@ -634,6 +634,10 @@
                 buffer.append("{d '") //$NON-NLS-1$
                       .append(val)
                       .append("'}"); //$NON-NLS-1$
+            } else if (type.equals(DataTypeManager.DefaultDataClasses.VARBINARY)) {
+            	buffer.append("X'") //$NON-NLS-1$
+            		  .append(val)
+            		  .append("'"); //$NON-NLS-1$
             } else {
                 buffer.append(Tokens.QUOTE)
                       .append(escapeString(val, Tokens.QUOTE))
Index: engine/src/test/java/org/teiid/query/parser/TestParser.java
===================================================================
--- engine/src/test/java/org/teiid/query/parser/TestParser.java	(revision 3801)
+++ engine/src/test/java/org/teiid/query/parser/TestParser.java	(working copy)
@@ -5205,7 +5205,13 @@
     
     @Test public void testExactFixedPoint() throws QueryParserException {
 		Query actualCommand = (Query)QueryParser.getQueryParser().parseCommand("SELECT 1.1", new ParseInfo());
-		assertEquals(DataTypeManager.DefaultDataClasses.BIG_DECIMAL, ((Expression)actualCommand.getSelect().getSymbol(0)).getType());
+		assertEquals(DataTypeManager.DefaultDataClasses.BIG_DECIMAL, actualCommand.getSelect().getSymbol(0).getType());
+    }
+    
+    @Test public void testBinaryStringLiteral() throws QueryParserException {
+		Query actualCommand = (Query)QueryParser.getQueryParser().parseCommand("SELECT x'AABBCC0a'", new ParseInfo());
+		assertEquals(DataTypeManager.DefaultDataClasses.VARBINARY, actualCommand.getSelect().getSymbol(0).getType());
+		assertEquals("SELECT X'AABBCC0A'", actualCommand.toString());
     }
 
 }
Index: engine/src/test/java/org/teiid/common/buffer/impl/TestSizeUtility.java
===================================================================
--- engine/src/test/java/org/teiid/common/buffer/impl/TestSizeUtility.java	(revision 3801)
+++ engine/src/test/java/org/teiid/common/buffer/impl/TestSizeUtility.java	(working copy)
@@ -34,6 +34,7 @@
 import java.util.List;
 
 import org.junit.Test;
+import org.teiid.core.types.BinaryType;
 import org.teiid.core.types.DataTypeManager;
 
 public class TestSizeUtility {
@@ -144,7 +145,7 @@
     
     @Test public void testGetSizeByteArray() {
         byte[] bytes = {0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10};
-        helpTestGetSize(bytes, 32);
+        helpTestGetSize(new BinaryType(bytes), 32);
     }
     
     @Test public void testResultSet() {
Index: common-core/src/main/java/org/teiid/core/types/BinaryType.java
===================================================================
--- common-core/src/main/java/org/teiid/core/types/BinaryType.java	(revision 0)
+++ common-core/src/main/java/org/teiid/core/types/BinaryType.java	(revision 0)
@@ -0,0 +1,112 @@
+/*
+ * JBoss, Home of Professional Open Source.
+ * See the COPYRIGHT.txt file distributed with this work for information
+ * regarding copyright ownership.  Some portions may be licensed
+ * to Red Hat, Inc. under one or more contributor license agreements.
+ * 
+ * This library is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU Lesser General Public
+ * License as published by the Free Software Foundation; either
+ * version 2.1 of the License, or (at your option) any later version.
+ * 
+ * This library is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * Lesser General Public License for more details.
+ * 
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with this library; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+ * 02110-1301 USA.
+ */
+
+package org.teiid.core.types;
+
+import java.util.Arrays;
+
+import javax.xml.bind.DatatypeConverter;
+
+import org.teiid.core.util.Assertion;
+
+public class BinaryType implements Comparable<BinaryType> {
+	
+	private byte[] bytes;
+	
+	public BinaryType(byte[] bytes) {
+		Assertion.isNotNull(bytes);
+		//to be truly immutable we should clone here
+		this.bytes = bytes;
+	}
+	
+	/**
+	 * 
+	 * @return the actual bytes - no modifications should be performed
+	 */
+	public byte[] getBytesDirect() {
+		return this.bytes;
+	}
+	
+	/**
+	 * 
+	 * @return a copy of the bytes
+	 */
+	public byte[] getBytes() {
+		return Arrays.copyOf(bytes, bytes.length);
+	}
+	
+	/**
+	 * Get the byte value at a given index
+	 * @param index
+	 * @return
+	 */
+	public byte getByte(int index) {
+		return bytes[index]; 
+	}
+	
+	public int getLength() {
+		return bytes.length;
+	}
+	
+	@Override
+	public int compareTo(BinaryType o) {
+		int len1 = getLength();
+		int len2 = o.getLength();
+		int n = Math.min(len1, len2);
+	    for (int i = 0; i < n; i++) {
+	    	//unsigned comparison
+			int b1 = bytes[i] & 0xff;
+			int b2 = o.bytes[i] & 0xff;
+			if (b1 != b2) {
+			    return b1 - b2;
+			}
+	    }
+		return len1 - len2;
+	}
+	
+	@Override
+	public int hashCode() {
+		return Arrays.hashCode(bytes);
+	}
+	
+	@Override
+	public boolean equals(Object obj) {
+		if (obj == this) {
+			return true;
+		}
+		if (!(obj instanceof BinaryType)) {
+			return false;
+		}
+		BinaryType other = (BinaryType)obj;
+		return Arrays.equals(this.bytes, other.bytes);
+	}
+	
+	@Override
+	public String toString() {
+		return DatatypeConverter.printHexBinary(bytes);
+	}
+	
+	public BlobType toBlob() {
+		return new BlobType(BlobType.createBlob(bytes));
+	}
+
+}
